Panda3D

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
RenderAttrib Class Referenceabstract

This is the base class for a number of render attributes (other than transform) that may be set on scene graph nodes to control the appearance of geometry. More...

`#include "renderAttrib.h"`

Inheritance diagram for RenderAttrib:

## Public Types
enum | PandaCompareFunc { M_none =0 , M_never , M_less , M_equal , M_less_equal , M_greater , M_not_equal , M_greater_equal , M_always }
enum | TexGenMode { M_off , M_eye_sphere_map , M_world_cube_map , M_eye_cube_map , M_world_normal , M_eye_normal , M_world_position , M_unused , M_eye_position , M_point_sprite , M_unused2 , M_constant }

## Public Member Functions
| RenderAttrib (const RenderAttrib &copy)=delete
virtual | ~RenderAttrib ()
| The destructor is responsible for removing the RenderAttrib from the global set if it is there. More...
int | compare_to (const RenderAttrib &other) const
| CPT (RenderAttrib) compose(const RenderAttrib *other) const
| CPT (RenderAttrib) get_unique() const
| CPT (RenderAttrib) invert_compose(const RenderAttrib *other) const
virtual bool | cull_callback (CullTraverser *trav, const CullTraverserData &data) const
| If has_cull_callback() returns true, this function will be called during the cull traversal to perform any additional operations that should be performed at cull time. More...
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed. More...
virtual TypeHandle | force_init_type ()
size_t | get_hash () const
virtual int | get_slot () const =0
virtual TypeHandle | get_type () const
virtual bool | has_cull_callback () const
| Should be overridden by derived classes to return true if cull_callback() has been defined. More...
virtual bool | lower_attrib_can_override () const
| Intended to be overridden by derived RenderAttrib types to specify how two consecutive RenderAttrib objects of the same type interact. More...
RenderAttrib & | operator= (const RenderAttrib &copy)=delete
virtual void | output (std::ostream &out) const
virtual bool | unref () const final
| This method overrides ReferenceCount::unref() to clear the pointer from the global object pool when its reference count goes to zero. More...
virtual void | write (std::ostream &out, int indent_level) const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file. More...
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type. More...
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin(). More...
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object. More...
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string. More...
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter. More...
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams. More...
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed. More...
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates. More...
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type. More...
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly. More...
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type. More...
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object. More...
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise. More...
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack. More...
void | ref () const
| Explicitly increments the reference count. More...
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero. More...
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus. More...
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one. More...
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object. More...
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object. More...

## Static Public Member Functions
static TypedWritable * | change_this (TypedWritable *old_ptr, BamReader *manager)
| Called immediately after complete_pointers(), this gives the object a chance to adjust its own pointer if desired. More...
static int | garbage_collect ()
| Performs a garbage-collection cycle. More...
static TypeHandle | get_class_type ()
static int | get_num_attribs ()
| Returns the total number of unique RenderAttrib objects allocated in the world. More...
static void | init_attribs ()
| Make sure the global _attribs map is allocated. More...
static void | init_type ()
static void | list_attribs (std::ostream &out)
| Lists all of the RenderAttribs in the cache to the output stream, one per line. More...
static int | register_slot (TypeHandle type_handle, int sort, RenderAttrib *default_attrib)
| Adds the indicated TypeHandle to the registry, if it is not there already, and returns a unique slot number. More...
static bool | validate_attribs ()
| Ensures that the cache is still stored in sorted order. More...
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes. More...
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96. More...
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| get_slot
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count. More...

## Friends
class | RenderAttribRegistry

## Additional Inherited Members
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

This is the base class for a number of render attributes (other than transform) that may be set on scene graph nodes to control the appearance of geometry.

This includes TextureAttrib, ColorAttrib, etc.

RenderAttrib represents render attributes that always propagate down to the leaves without regard to the particular node they are assigned to. A RenderAttrib will have the same effect on a leaf node whether it is assigned to the graph at the leaf or several nodes above. This is different from RenderEffect, which represents a particular render property that is applied immediately to the node on which it is encountered, like billboarding or decaling.

You should not attempt to create or modify a RenderAttrib directly; instead, use the make() method of the appropriate kind of attrib you want. This will allocate and return a new RenderAttrib of the appropriate type, and it may share pointers if possible. Do not modify the new RenderAttrib if you wish to change its properties; instead, create a new one.

Definition at line 51 of file renderAttrib.h.

## Constructor & Destructor Documentation

## ◆ ~RenderAttrib()

RenderAttrib::~RenderAttrib | ( |  | ) |
| virtual

The destructor is responsible for removing the RenderAttrib from the global set if it is there.

Definition at line 46 of file renderAttrib.cxx.

## Member Function Documentation

## ◆ change_this()

TypedWritable * RenderAttrib::change_this | ( | TypedWritable * | old_ptr,
|  | BamReader * | manager
| ) |  |
| static

Called immediately after complete_pointers(), this gives the object a chance to adjust its own pointer if desired.

Most objects don't change pointers after completion, but some need to.

Once this function has been called, the old pointer will no longer be accessed.

Definition at line 539 of file renderAttrib.cxx.

## ◆ cull_callback()

bool RenderAttrib::cull_callback | ( | CullTraverser * | trav,
|  | const CullTraverserData & | data
| ) |  | const
| virtual

If has_cull_callback() returns true, this function will be called during the cull traversal to perform any additional operations that should be performed at cull time.

This is called each time the RenderAttrib is discovered applied to a Geom in the traversal. It should return true if the Geom is visible, false if it should be omitted.

Reimplemented in TextureAttrib.

Definition at line 96 of file renderAttrib.cxx.

## ◆ finalize()

void RenderAttrib::finalize | ( | BamReader * | manager | ) |
| virtual

Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.

Reimplemented from TypedWritable.

Reimplemented in LightAttrib, and ClipPlaneAttrib.

Definition at line 564 of file renderAttrib.cxx.

References unref().

## ◆ garbage_collect()

int RenderAttrib::garbage_collect | ( |  | ) |
| static

Performs a garbage-collection cycle.

This is called automatically from RenderState::garbage_collect(); see that method for more information.

Definition at line 187 of file renderAttrib.cxx.

Referenced by RenderState::garbage_collect().

## ◆ get_num_attribs()

int RenderAttrib::get_num_attribs | ( |  | ) |
| static

Returns the total number of unique RenderAttrib objects allocated in the world.

This will go up and down during normal operations.

Definition at line 156 of file renderAttrib.cxx.

References SimpleHashMap< Key, Value, Compare >::get_num_entries().

## ◆ has_cull_callback()

bool RenderAttrib::has_cull_callback | ( |  | ) | const
| virtual

Should be overridden by derived classes to return true if cull_callback() has been defined.

Otherwise, returns false to indicate cull_callback() does not need to be called for this node during the cull traversal.

Reimplemented in TextureAttrib.

Definition at line 82 of file renderAttrib.cxx.

## ◆ init_attribs()

void RenderAttrib::init_attribs | ( |  | ) |
| static

Make sure the global _attribs map is allocated.

This only has to be done once. We could make this map static, but then we run into problems if anyone creates a RenderAttrib object at static init time; it also seems to cause problems when the Panda shared library is unloaded at application exit time.

Definition at line 510 of file renderAttrib.cxx.

Referenced by init_libpgraph().

## ◆ list_attribs()

void RenderAttrib::list_attribs | ( | std::ostream & | out | ) |
| static

Lists all of the RenderAttribs in the cache to the output stream, one per line.

This can be quite a lot of output if the cache is large, so be prepared.

Definition at line 171 of file renderAttrib.cxx.

References SimpleHashMap< Key, Value, Compare >::get_key(), and SimpleHashMap< Key, Value, Compare >::get_num_entries().

## ◆ lower_attrib_can_override()

bool RenderAttrib::lower_attrib_can_override | ( |  | ) | const
| virtual

Intended to be overridden by derived RenderAttrib types to specify how two consecutive RenderAttrib objects of the same type interact.

This should return false if a RenderAttrib on a higher node will compose into a RenderAttrib on a lower node that has a higher override value, or true if the lower RenderAttrib will completely replace the state.

The default behavior is false: normally, a RenderAttrib in the graph cannot completely override a RenderAttrib above it, regardless of its override value–instead, the two attribs are composed. But for some kinds of RenderAttribs, it is useful to allow this kind of override.

This method only handles the one special case of a lower RenderAttrib with a higher override value. If the higher RenderAttrib has a higher override value, it always completely overrides. And if both RenderAttribs have the same override value, they are always composed.

Reimplemented in TextureAttrib, and ColorScaleAttrib.

Definition at line 72 of file renderAttrib.cxx.

## ◆ register_slot()

int RenderAttrib::register_slot | ( | TypeHandle | type_handle,
|  | int | sort,
|  | RenderAttrib * | default_attrib
| ) |  |
| inline static

Adds the indicated TypeHandle to the registry, if it is not there already, and returns a unique slot number.

See RenderAttribRegistry.

Definition at line 100 of file renderAttrib.I.

## ◆ unref()

bool RenderAttrib::unref | ( |  | ) | const
| final virtual

This method overrides ReferenceCount::unref() to clear the pointer from the global object pool when its reference count goes to zero.

Reimplemented from ReferenceCount.

Definition at line 105 of file renderAttrib.cxx.

Referenced by finalize().

## ◆ validate_attribs()

bool RenderAttrib::validate_attribs | ( |  | ) |
| static

Ensures that the cache is still stored in sorted order.

Returns true if so, false if there is a problem (which implies someone has modified one of the supposedly-const RenderAttrib objects).

Definition at line 260 of file renderAttrib.cxx.

References SimpleHashMap< Key, Value, Compare >::get_key(), SimpleHashMap< Key, Value, Compare >::get_num_entries(), SimpleHashMap< Key, Value, Compare >::is_empty(), and SimpleHashMap< Key, Value, Compare >::validate().

## ◆ write_datagram()

void RenderAttrib::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg
| ) |  |
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from TypedWritable.

Reimplemented in TransparencyAttrib, TextureAttrib, TexMatrixAttrib, TexGenAttrib, StencilAttrib, ShadeModelAttrib, ScissorAttrib, RescaleNormalAttrib, RenderModeAttrib, MaterialAttrib, LogicOpAttrib, LightRampAttrib, LightAttrib, FogAttrib, DepthWriteAttrib, DepthTestAttrib, DepthOffsetAttrib, CullFaceAttrib, CullBinAttrib, ColorWriteAttrib, ColorScaleAttrib, ColorBlendAttrib, ColorAttrib, ClipPlaneAttrib, AuxBitplaneAttrib, AudioVolumeAttrib, AntialiasAttrib, and AlphaTestAttrib.

Definition at line 526 of file renderAttrib.cxx.

References TypedWritable::write_datagram().

Referenced by AlphaTestAttrib::write_datagram(), AntialiasAttrib::write_datagram(), AudioVolumeAttrib::write_datagram(), AuxBitplaneAttrib::write_datagram(), ClipPlaneAttrib::write_datagram(), ColorAttrib::write_datagram(), ColorBlendAttrib::write_datagram(), ColorScaleAttrib::write_datagram(), ColorWriteAttrib::write_datagram(), CullBinAttrib::write_datagram(), CullFaceAttrib::write_datagram(), DepthOffsetAttrib::write_datagram(), DepthTestAttrib::write_datagram(), DepthWriteAttrib::write_datagram(), FogAttrib::write_datagram(), LightAttrib::write_datagram(), LightRampAttrib::write_datagram(), LogicOpAttrib::write_datagram(), MaterialAttrib::write_datagram(), RenderModeAttrib::write_datagram(), RescaleNormalAttrib::write_datagram(), ScissorAttrib::write_datagram(), ShadeModelAttrib::write_datagram(), StencilAttrib::write_datagram(), TexGenAttrib::write_datagram(), TexMatrixAttrib::write_datagram(), TextureAttrib::write_datagram(), and TransparencyAttrib::write_datagram().

The documentation for this class was generated from the following files:

- panda/src/pgraph/renderAttrib.h
- panda/src/pgraph/renderAttrib.cxx
- panda/src/pgraph/renderAttrib.I